#include <Wire.h>
#include <OneWire.h>
#include <SPI.h>
#include <BlueDot_BME280.h>
#include <SFE_MicroOLED.h>  // Include the SFE_MicroOLED library
#include <DallasTemperature.h>
#define AKEY "YaMOPLz"
#define PIN_RESET 255
#define DC_JUMPER 0
#define DS18B20 2
#define LABLE "*KLOP-MNU*"
// version 1.9
#define VER_  "2021-04-05"

char degrSign = 247;
OneWire oneWire(DS18B20);                   
DallasTemperature TempP(&oneWire);
MicroOLED oled (PIN_RESET, DC_JUMPER);
BlueDot_BME280 bme2;

bool bme2Detected=false;
bool tempDetected=false;
String JSONstr="";
char DallasT[10];
char bme2T[10];
char bme2H[10];
char bme2P[10];

// буферы для преобразования ср. знач. из double в char[10] и печать
char aver_bme2T[10];
char aver_bme2H[10];
char aver_bme2P[10];

char VS[10];

double bme_t_mass[5] = {0};
double bme_t_aver = 0;

double bme_p_mass[5] = {0};
double bme_p_aver = 0;

double bme_h_mass[5] = {0};
double bme_h_aver = 0;

double dallas_mass[5] = {0};
double dallas_aver = 0;

int aver_denom = 0;

int c = 0;
String WaitS = "-";
void setup() {
    // Open connection to Arduino/Iskra
    Serial.begin(115200); 
    // OLED init
    Wire.begin();
    oled.begin();                         // Инициируем работу с OLED дисплеем
    oled.clear(ALL);                      // Чистим графическую память дисплея (избавляемся от артефактов которые могли появиться при подаче питания)
    oled.display();                       // Выводим данные из буфера библиотеки на дисплей
    delay(1000);                          // Устанавливаем задержку на 1 секунду
    oled.clear(PAGE);                     // Чистим графический буфер библиотеки
    oled.setFontType(0);                  // Устанавливаем шрифт с номером 0 (0-5x7, 1-8x16, 2-семисегментный, 3-большие цифры, 4-31x48)

    TempP.begin();
    if(tempDetected=(TempP.getDeviceCount()>0)){
      Serial.println("1-Wire Temp Sensor detected!");
      //tempDetected=true;
    }else{
      Serial.println("1-Wire Temp Sensor not found!");
      //tempDetected=false;
    }

    bme2.parameter.communication = 0;
    bme2.parameter.I2CAddress = 0x76; //для фиолетовых BME280
    //bme2.parameter.I2CAddress = 0x77; //для красных BME280
    bme2.parameter.sensorMode = 0b11;
    bme2.parameter.IIRfilter = 0b100;
    bme2.parameter.humidOversampling = 0b101;
    bme2.parameter.tempOversampling = 0b101;
    bme2.parameter.pressOversampling = 0b101;
    bme2.parameter.pressureSeaLevel = 1013.25;
    bme2.parameter.tempOutsideCelsius = 15;

    if(bme2Detected=(bme2.init()==0x60)){    
      Serial.println("BME280 Sensor detected!");
    }else{
      Serial.println("BME280 Sensor not found!");
    }
}

    
void loop() { 
    
    if(tempDetected){
      TempP.requestTemperatures();
      dtostrf(TempP.getTempCByIndex(0),6,2,DallasT);
    }else{
      strcpy(DallasT,"\"none\"");
    }
    if(bme2Detected){
      dtostrf(bme2.readTempC(),4,1,bme2T);
      dtostrf(bme2.readHumidity(),5,1,bme2H);
      dtostrf(bme2.readPressure()*0.750064,5,1,bme2P);
    }else{
      strcpy(bme2T,"\"none\"");
      strcpy(bme2H,"\"none\"");
      strcpy(bme2P,"\"none\"");
    }
    dtostrf(analogRead(A0)*3.3/1023.*2,4,2,VS);
    //Вывод на OLED
    oled.clear(PAGE);
    oled.setCursor(0, 0); 
    
//    Cчетчик 
    c = c + 2;
    oled.println(WaitS);
    if (c==12 || c==18 || c==24 || c==30 || c==36 || c==42 || c==48 || c==54 || c==60){
      WaitS = WaitS + "-";
      if (c >= 60){
        c==60;
        WaitS = ""; 
      }
    }

    if(aver_denom < 5){
      aver_denom++;
      }

    bme_t_mass[4] = bme_t_mass[3];
    bme_t_mass[3] = bme_t_mass[2];
    bme_t_mass[2] = bme_t_mass[1];
    bme_t_mass[1] = bme_t_mass[0];
    bme_t_mass[0] = strtod(bme2T, NULL);
    bme_t_aver = (bme_t_mass[0] + bme_t_mass[1] + bme_t_mass[2] + bme_t_mass[3] + bme_t_mass[4])/ aver_denom;

    bme_p_mass[4] = bme_p_mass[3];
    bme_p_mass[3] = bme_p_mass[2];
    bme_p_mass[2] = bme_p_mass[1];
    bme_p_mass[1] = bme_p_mass[0];
    bme_p_mass[0] = strtod(bme2P, NULL);
    bme_p_aver = (bme_p_mass[0] + bme_p_mass[1] + bme_p_mass[2] + bme_p_mass[3] + bme_p_mass[4])/ aver_denom;

    bme_h_mass[4] = bme_h_mass[3];
    bme_h_mass[3] = bme_h_mass[2];
    bme_h_mass[2] = bme_h_mass[1];
    bme_h_mass[1] = bme_h_mass[0];
    bme_h_mass[0] = strtod(bme2H, NULL);
    bme_h_aver = (bme_h_mass[0] + bme_h_mass[1] + bme_h_mass[2] + bme_h_mass[3] + bme_h_mass[4])/ aver_denom;

    dallas_mass[4] = dallas_mass[3];
    dallas_mass[3] = dallas_mass[2];
    dallas_mass[2] = dallas_mass[1];
    dallas_mass[1] = dallas_mass[0];
    dallas_mass[0] = strtod(DallasT, NULL);
    dallas_aver = (dallas_mass[0] + dallas_mass[1] + dallas_mass[2] + dallas_mass[3] + dallas_mass[4])/ aver_denom;

    // преобразование ср. знач. из double в char[10] буферы
    dtostrf(bme_t_aver,4,1,aver_bme2T);
    dtostrf(bme_h_aver,5,1,aver_bme2H);
    dtostrf(bme_p_aver,5,1,aver_bme2P);
    
    oled.print(String(LABLE));
    oled.setCursor(0, 21);
    //oled.print("T0="+String(bme2T)+" "+degrSign+"C");

    // старая последняя версия
    ////oled.print("T="+String(bme_t_aver)+" "+degrSign+"C ");
      oled.print("T= "+String(aver_bme2T)+" "+degrSign+"C ");
      
    //oled.println("T="+String(dallas_aver)+" "+degrSign+"C");
    oled.setCursor(0, 31);
    
    // старая последняя версия
    ////oled.print("P="+String(bme_p_aver)+" Hg");
      oled.print("P="+String(aver_bme2P)+" Hg");
      
    oled.setCursor(0, 41);
    
    // старая последняя версия
    ////oled.print("H="+String(bme_h_aver)+" %");
      oled.print("H="+String(aver_bme2H)+" %");
      
    oled.display();

    //генерация JSON
    JSONstr = "{ ";
    // Системные
    JSONstr += "\"system\":{";
    JSONstr += "\"Akey\":\"" + String(AKEY) + "\", ";
    JSONstr += "\"Version\":\"" + String(VER_) + "\", ";
    JSONstr += "\"Upit\":" + String(VS);
    JSONstr += "}, ";
    // DS8B20
    JSONstr += "\"DS18B20\":{";
    JSONstr += "\"temp\":" + String(DallasT);
    JSONstr += "\"temp_average\":" + String(dallas_aver);
    JSONstr += "}, ";
    //BME280
    JSONstr += "\"BME280\":{";
    JSONstr += "\"temp\":" + String(bme2T) + ", ";
    JSONstr += "\"temp_average\":" + String(bme_t_aver) + ", ";
    JSONstr += "\"humidity\":" + String(bme2H) + ", ";
    JSONstr += "\"humidity_average\":" + String(bme_h_aver) + ", ";
    JSONstr += "\"pressure\":" + String(bme2P);
    JSONstr += "\"pressure_average\":" + String(bme_p_aver) + ", ";
    JSONstr += "}";
    //
    JSONstr += " }";

    //Передача пакета в Serial
    Serial.println(JSONstr);
    delay(1000);

}
